<copyright> It InspectorManager class.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1998 Pieter J. Schoenmakers.

    This file is part of It.  It is distributed under the terms of the
    It License, a copy of which can be found in the It distribution; see
    the file LICENSE.

    <id>$Id: InspectorManager.t,v 1.1 1998/04/15 22:45:55 tiggr Exp $</id>
    </copyright>

implementation class
InspectorManager: it
{
  <doc> The (for now) shared inspector manager.  </doc>
  static instance (id) shared;
}

<doc> Return the shared and only InspectorManager instance.  </doc>
instance (id)
  shared
{
  if (!shared)
    shared = [self new];
  = shared;
}

end;

implementation instance
InspectorManager
{
  <doc> The inspector window.  </doc>
  Panel window;

  <doc> The view in which we plug the inspector views.  </doc>
  View inspector_super;

  <doc> The current inspector.  </doc>
  Inspector current_inspector;

  <doc> And its view.  </doc>
  View current_inspector_view;
}

<doc> Designated initializer.  </doc>
id
  init
{
  Screen s = [system_display defaultScreen];

  window = [s panelWithContentRect (600.0, 600.0, INSPECTOR_WIDTH,
				    INSPECTOR_HEIGHT + 50.0)
	      styleMask WINDOW_STYLE_TITLED backing BACKING_STORE_RETAINED];
  [window setTitle "It!spector"];

  inspector_super = [[View alloc] initFrame (0.0, 0.0, INSPECTOR_WIDTH,
					     INSPECTOR_HEIGHT)];
  [[window content_view] addSubview inspector_super];

  // The order should be the other way round, but invoking display on a
  // View in a window that is not yet on the screen, will cause trouble.
  // Thu Apr 16 00:08:09 1998, tiggr@gerbil.org
  [window orderFront self];
  [self set_inspector [[PlainInspector shared] withTitle "Empy selection"]];

  = [super init];
}

void
  reflectSelection Indexed selection
		in Document doc
{
  int n = [selection length];
  Inspector i;
  if (!n)
    i = [[PlainInspector shared] withTitle "Empty selection"];
  else if (n > 1)
    i = [[PlainInspector shared] withTitle "Multiple selection"];
  else
    i = [selection[0] customInspector];
  [self set_inspector i];
}

void
  set_inspector Inspector gadget
{
  if (current_inspector_view != nil)
    [current_inspector_view removeFromSuperview];
  current_inspector = gadget;
  current_inspector_view = [current_inspector view];
  [inspector_super addSubview current_inspector_view];
  [inspector_super display];
}

end;
