<copyright> It Layer class.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1998 Pieter J. Schoenmakers.

    This file is part of It.  It is distributed under the terms of the
    It License, a copy of which can be found in the It distribution; see
    the file LICENSE.

    <id>$Id: Layer.t,v 1.11 1998/04/13 16:55:28 tiggr Exp $</id>
    </copyright>

implementation class
Layer: it

end;

implementation instance
Layer
{
  <doc> The document to which this layer belongs.  </doc>
  public Document document;
}

<doc> Designated initializer.  </doc>
id
  initWithDocument Document d
{
  document = d;
  = [super init];
}

<doc> Return {TRUE} if the receiving layer accepts new objects, to be
    added through {addObject}.  The default implementation returns
    {FALSE}.  </doc>
boolean
  acceptsNewObjects
{
}

<doc> Return an as accurate as possible value for the bounding box.  The
    default implementation returns the bounding box.  </doc>
(float, float, float, float)
  accurateBBox Document doc
{
  = [self bbox];
}

<doc> Add the object {o} to the receiving layer.  </doc>
int
  addObject Object o
{
  [self shouldNotImplement cmd];
}

<doc> Return the bounding box of the contents of the receiving layer.
    Layers that do display something but do not /contain/ anything would
    return an empty rectangle (e.g., the grid, the guides, etc.).  The
    default implementation returns an empty rectangle.  </doc>
(float, float, float, float)
  bbox
{
}

<doc> Add to the {display} and {edit} sets those plugits that are needed
    to display the receiving layer and its contents, once retrieved from
    being saved, and the plugits needed to edit it, respectively.  Plugits
    that are needed for display need not be include in {edit}.  </doc>
void
  collectPlugIts (MutableKeyed, MutableKeyed) (display, edit)
{
}

<doc> Layer drawing method.  Do everything a {View} would do to draw
    itself.  The {Document} {doc} is the {View} having the locked focus.

    Real layers should override this method, in which case there is no
    need to pass to {super}.  </doc>
void
  drawSelf (float, float, float, float) (x, y, w, h)
	in Document doc
{
}

<doc> Return the object being hit (closest) within the receiving layer.
    The default implementation returns a {nil} {object}.  The {auxiliary}
    information is anything the {object} may need.  </doc>
(Object, int, All, float, int) (object, action, auxiliary, distance, priority)
  hitTest (float, float) (x, y)
  partial boolean partial_p
{
}

<doc> The location {(x, y)} of the event {e} is offered by the {document}
    of this layer to be locked at some position, be it a point or some
    grid.  Return {locked == TRUE} if the {new_x} and {new_y} are the
    locked equivalent of the offered position.  {x} and {y} are in the
    coordinate system of the document.  The default implementation returns
    {locked = FALSE}.  </doc>
(boolean, float, float) (locked, new_x, new_y)
  lockEvent MouseEvent e
   location (float, float) (x, y)
{
}

<doc> Apply a rubberbanding selection with the given rectangle.  Return
    the rectangle to be displayed to make the changes to the selection
    decorations visible.  The default implementation does nothing and
    returns an empty rectangle.  </doc>
(float, float, float, float)
  selectRubber (float, float, float, float) (x, y, w, h)
{
}

/******************** Archiving ********************/
<doc><h4>Archiving</h4></doc>

id (self)
  awakeAfterUsingCoder Decoder coder
{
  document = [Document current_document];
  = [super awakeAfterUsingCoder coder];
}

end;
