<copyright> It Modification class.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1998 Pieter J. Schoenmakers.

    This file is part of It.  It is distributed under the terms of the
    It License, a copy of which can be found in the It distribution; see
    the file LICENSE.

    <id>$Id: Modification.t,v 1.3 1998/03/20 00:24:15 tiggr Exp $</id>
    </copyright>

implementation class
Modification: it

end;

implementation instance
Modification

<doc> Undo the effect of the receiving modification.  The Document {doc},
    to which this mod applies, is in the same state as after this
    modification was done last.  Return the affected bounding box.  </doc>
deferred (float, float, float, float)
  undo Document doc;

<doc> Redo the effect of the receiving modification.  The Document {doc},
    to which this mod applies, is in the same state as before the
    modification was created.  </doc>
deferred (float, float, float, float)
  redo Document doc;

end;

/******************** PointModification ********************/

implementation class
PointModification: Modification

end;

implementation instance
PointModification
{
  <doc> The shape to which this point can belong.  </doc>
  Shape shape;

  <doc> The point.  </doc>
  Point point;

  <doc> The index at which this point resides when in the shape.  </doc>
  int index;
}

<doc> Designated initializer.  </doc>
id
  initWithPoint Point p
	inShape Shape s
	atIndex int i
{
  (shape, point, index) = (s, p, i);
  = [super init];
}

end;


/******************** PointAddModification ********************/

implementation class
PointAddModification: PointModification

end;

implementation instance
PointAddModification

<doc> Redo the effect of this modification.  </doc>
(float, float, float, float) (sx, sy, sw, sh)
  redo Document doc
pre
  doc == [[shape layer] document]
{
  (sx, sy, sw, sh) = [shape decoratedBBox];
  [shape addPoint point position index];
  = [tag unionRect (sx, sy, sw, sh) with [shape decoratedBBox]];
}

<doc> Redo the effect of this modification.  </doc>
(float, float, float, float) (sx, sy, sw, sh)
  undo Document doc
pre
  doc == [[shape layer] document]
{
  (sx, sy, sw, sh) = [shape decoratedBBox];
  [shape removePoint index];
  = [tag unionRect (sx, sy, sw, sh) with [shape decoratedBBox]];
}

end;

/******************** PointRemoveModification ********************/

implementation class
PointRemoveModification: PointModification

end;

implementation instance
PointRemoveModification

<doc> Redo the effect of this modification.  </doc>
(float, float, float, float) (sx, sy, sw, sh)
  redo Document doc
pre
  doc == [[shape layer] document]
{
  (sx, sy, sw, sh) = [shape decoratedBBox];
  [shape removePoint index];
  = [tag unionRect (sx, sy, sw, sh) with [shape decoratedBBox]];
}

<doc> Redo the effect of this modification.  </doc>
(float, float, float, float) (sx, sy, sw, sh)
  undo Document doc
pre
  doc == [[shape layer] document]
{
  (sx, sy, sw, sh) = [shape decoratedBBox];
  [shape addPoint point position index];
  = [tag unionRect (sx, sy, sw, sh) with [shape decoratedBBox]];
}

end;

