<copyright> It NotificationCenter.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1998 Pieter J. Schoenmakers.

    This file is part of It.  It is distributed under the terms of the
    It License, a copy of which can be found in the It distribution; see
    the file LICENSE.

    <id>$Id: NotificationCenter.t,v 1.3 1998/03/09 21:26:34 tiggr Exp $</id>
    </copyright>

implementation class
NotificationCenter: State
{
  /* A cvar can not be named `default'...  */
  static NotificationCenter default_center;
}

instance (id)
  default
{
  if (!default_center)
    default_center = [self new];
  = default_center;
}

end;

implementation instance
NotificationCenter
{
  <doc> The {Notifier}s not interested in a particular notification; these
      want all notifications.  </doc>
  MutableIndexed blank_notifiers;

  <doc> The notifiers, keyed on the name of the notification.  Each value
      is a {MutableIndexed} containing {Notifier}s.  </doc>
  MutableMapped notifiers;
}

<doc> Designated initializer.  </doc>
id
  init
{
  blank_notifiers = [MutableObjectArray new];
  notifiers = [MutableDictionary new];
  = [super init];
}

void
  addObserver All observer
     selector selector sel
	 name UniqueString notification_name
      object: All notification_object = nil
{
  Notifier n = [[Notifier alloc] initWithName notification_name
				 object notification_object
				 observer observer selector sel];
  if (!notification_name)
    [blank_notifiers add n];
  else
    {
      MutableIndexed named = notifiers[notification_name];
      if (!named)
	{
	  named = [MutableObjectArray with n];
	  notifiers[notification_name] = named;
	}
      else
	[named add n];
    }
}

<doc> Post the {notification}.  Observers interested in all notifications,
    as opposed to a particular one, observe later than observers wanting
    specific notifications.  </doc>
void
  postNotification Notification notification
{
  String name = [notification name];
  MutableIndexed named = notifiers[name];

  if (named != nil)
    [named makeElementsPerform cmd with notification];
  [blank_notifiers makeElementsPerform cmd with notification];
}

void
  postNotificationNamed UniqueString name
		 object All object
{
  [self postNotification [[Notification alloc] initWithName name
					       object object]];
}

end;
