<copyright> It Notifier.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1998 Pieter J. Schoenmakers.

    This file is part of It.  It is distributed under the terms of the
    It License, a copy of which can be found in the It distribution; see
    the file LICENSE.

    <id>$Id: Notifier.t,v 1.3 1998/03/09 21:26:35 tiggr Exp $</id>
    </copyright>

implementation class
Notifier: State

end;

implementation instance
Notifier
{
  <doc> The name of the notifications this notifier is interested in.  If
      {name} is {nil}, all notifications are of interest.  </doc>
  UniqueString name;

  <doc> The object this notifier is interested in.  </doc>
  Any object;

  <doc> The observer.  </doc>
  All observer;

  <doc> How the observer is informed.  This selector must accept one
      reference argument.  </doc>
  selector method;
}

<doc> Designated initializer.  </doc>
id
  initWithName UniqueString n
	object All obj
      observer All obs
      selector selector sel
{
  (name, object, observer, method) = (n, Any (obj), obs, sel);
  = [super init];
}

<doc> If the {notification} matches, inform the observer.  </doc>
void
  postNotification Notification notification
{
  All o = [notification object];

  if ((!name || [notification name] == name)
      && (!object || object == o))
    {
      // It should be configurable whether the OBSERVER gets the OBJECT or
      // the NOTIFICATION as the argument.
      // Mon Feb 23 00:20:50 1998, tiggr@gerbil.org
      [observer perform method with o];
    }
}

end;
