<copyright> It Ellipse and ellipse classes.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1998 Pieter J. Schoenmakers.

    This file is part of It.  It is distributed under the terms of the
    It License, a copy of which can be found in the It distribution; see
    the file LICENSE.

    <id>$Id: Ellipse.t,v 1.2 1998/04/21 22:47:49 tiggr Exp $</id>
    </copyright>

/******************** ellipse ********************/

implementation class
ellipse: PlugIt

end;

implementation instance
ellipse

<doc> Designated initializer.  </doc>
id
  init
{
  = [super init];
  [[ToolKit shared] newTool [EllipseTool self]];
}

String
  plugItName
{
  = "ellipse";
}

int
  plugItVersion
{
  = 0;
}

end;

/******************** Ellipse ********************/

implementation class
Ellipse: SimpleObject

end;

implementation instance
Ellipse

<doc> Add the {ellipse} plugit to {display}.  </doc>
void
  collectPlugIts (MutableKeyed, MutableKeyed) (display, edit)
{
  [display add [ellipse shared]];
}

void
  drawSelf (float, float, float, float) (x, y, w, h)
	in Document doc
{
  Display d = [doc currentDisplay];
  [d setColor [Color black]];
  [d newpath];

  float x0 = (brx + trx) / 2.0, y0 = (bry + try) / 2.0;
  float x3 = (tlx + trx) / 2.0, y3 = (tly + try) / 2.0;

  [d moveto (x0, y0)];

  // This 0.55 has not been computed, but `measured'...  (I thought, from
  // computation with a fit a t=0, t=1. and t=0.5, that it should be 0.62,
  // but that (still) doesn't look good.)
  // Wed Apr 22 00:44:57 1998, tiggr@gerbil.org
  float a_prime = 0.55 * (x0 - x3);
  float b_prime = 0.55 * (y3 - y0);

  float x1 = x0;
  float y1 = y0 + b_prime;
  float x2 = x3 + a_prime;
  float y2 = y3;

  [d curveto (x1, y1, x2, y2, x3, y3)];

  (x0, y0) = (x3, y3);
  (x3, y3) = ((blx + tlx) / 2.0, (bly + tly) / 2.0);

  x1 = x0 - a_prime;
  y1 = y0;
  x2 = x3;
  y2 = y3 + b_prime;

  [d curveto (x1, y1, x2, y2, x3, y3)];

  (x0, y0) = (x3, y3);
  (x3, y3) = ((blx + brx) / 2.0, (bly + bry) / 2.0);

  x1 = x0;
  y1 = y0 - b_prime;
  x2 = x3 - a_prime;
  y2 = y3;

  [d curveto (x1, y1, x2, y2, x3, y3)];

  (x0, y0) = (x3, y3);
  (x3, y3) = ((brx + trx) / 2.0, (bry + try) / 2.0);

  x1 = x0 + a_prime;
  y1 = y0;
  x2 = x3;
  y2 = y3 - b_prime;

  [d curveto (x1, y1, x2, y2, x3, y3)];

  [d stroke];
}

end;
