<copyright> It it class.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1998 Pieter J. Schoenmakers.

    This file is part of It.  It is distributed under the terms of the
    It License, a copy of which can be found in the It distribution; see
    the file LICENSE.

    <id>$Id: it.t,v 1.20 1999/04/14 22:27:37 tiggr Exp $</id>
    </copyright>

implementation class
it: stdio, tag, Constants, Conditions
{
  <doc> The image for displaying a point.  This is set by the {Point}
      class.  </doc>
  static Image point_image;

  // These should be PRIVATE, but TM does not grok that.
  // Wed Apr 14 22:14:19 1999, tiggr@gerbil.org
  /* Names of the notifications.  Do not use these directly; use their
     lower-case equivalents, which are (faster) unique strings.  */
  const NOTIFICATION_DOCUMENT_NEW = "DocumentNew";
  const NOTIFICATION_DOCUMENT_OPEN = "DocumentOpen";
}

<doc> Display the image {im} centered around the point {(x, y)}.  </doc>
void
  centerImage Image im
	   at (float, float) (x, y)
{
  float w, h;
  (w, h) = [im size];

  // This computation of the location should be abstracted into a method.
  // Sat Apr 18 23:32:17 1998, tiggr@gerbil.org
  [im compositeToPoint (x - w / 2.0 + 0.5, y - h / 2.0 + 0.5)
      operation COMPOSITE_COPY];
}

<doc> Return a diagnostic stream.  </doc>
OutputStream
  diag
{
  = err;
}

<doc> Return a stream to which an error will be emitted.  </doc>
OutputStream
  error
{
  = [[self diag] print ("it:", [self name], ": ")];
}

<doc> Return the same rectangle, but with non-negative width and height.
    </doc>
(float, float, float, float) (nr_x, nr_y, nr_w, nr_h)
  fix_rectangle (float, float, float, float) (x, y, w, h)
{
  (nr_x, nr_y, nr_w, nr_h) = (x, y, w, h);
  if (nr_w < 0.0)
    (nr_x, nr_w) = (nr_x + nr_w, -nr_w);
  if (nr_h < 0.0)
    (nr_y, nr_h) = (nr_y + nr_h, -nr_h);
}

void
  initialize
{
  notification_document_new = [UniqueString with NOTIFICATION_DOCUMENT_NEW];
  notification_document_open = [UniqueString with NOTIFICATION_DOCUMENT_OPEN];
}

<doc> Do It!  </doc>
int
  main Indexed arguments
{
  ConditionClass cc = condition;

  [self initialize];

  bind ((cc,
	 {
	   [[err print ("signal: ", condition)] nl];
	   condition;
	 }))
    ({
      Application app = [Application shared];

      if (!app)
	= 1;
      else
	{
	  String dir = [[MutableByteString new]
			 print ([[Bundle main] directory], "images/")];

	  // Make our images directory visible.
	  [Bundle registerUnitDirectory dir];

	  selector sel;
	  Menu main_menu = [[Application shared] main_menu];
	  MenuCell mc = [main_menu addItem "File" action sel];
	  Menu file_menu = [[Menu alloc] initWithTitle "File"];
	  [main_menu hookSubmenu file_menu to mc];
	  mc = [main_menu addItem "Edit" action sel];
	  Menu edit_menu = [[Menu alloc] initWithTitle "Edit"];
	  [main_menu hookSubmenu edit_menu to mc];

	  [file_menu addItem "Save" action selector (void save All)];
	  [file_menu addItem "Export" action selector (void export All)];

	  [edit_menu addItem "Cut" action selector (void cut All)];
	  [edit_menu addItem "Copy" action selector (void copy All)];
	  [edit_menu addItem "Paste" action selector (void paste All)];
	  [edit_menu addItem "Undo" action selector (void undo All)];
	  [edit_menu addItem "Redo" action selector (void redo All)];

	  [ToolKit shared];
	  [InspectorManager shared];
	  [PlugIt loadPlugIts];

	  point_image = [Image named "point"];

	  int i, n = [arguments length], num_docs;
	  for (i = 0; i < n; i++)
	    {
	      String s = arguments[i];
	      if (s[0] == '-')
		[[[self error] print ("unknown option: ", s)] nl];
	      else
		{
		  [self newDocument s];
		  num_docs++;
		}
	    }

	  if (!num_docs)
	    [self newDocument nil];

	  [Application run];
	  = 0;
	}
    });
}

Document
  newDocument String filename
{
  Screen s = [system_display defaultScreen];
  Window wnd = [s windowWithContentRect (125.0, 400.0, 450.0, 550.0)
		  styleMask WINDOW_STYLE_TITLED | WINDOW_STYLE_RESIZABLE
		  backing BACKING_STORE_RETAINED];

  float w, h;
  (, , w, h) = [[wnd content_view] frame];
  
  // Should be y=0.0.
  // Sun Feb 22 20:54:37 1998, tiggr@gerbil.org
  ScrollView sv = [[ScrollView alloc] initFrame (0.0, 1.0, w, h)];
  ClipView cp = [[ClipView alloc] initFrame (0.0, 0.0, 0.0, 0.0)];
  [sv set_auto_size VIEW_SIZE_WIDTH | VIEW_SIZE_HEIGHT];
  [sv set_horizontal_scroller_required YES];
  [sv set_vertical_scroller_required YES];
  [sv set_content_view cp];

  Document d = [[Document alloc] initFrame (0.0, 0.0, 500.0, 800.0)
				 withFileNamed filename];
  [sv set_document_view d];
  [[wnd content_view] addSubview sv];
  [wnd set_initial_responder d];
  [wnd setTitle [d filename]];

  [wnd makeKeyAndOrderFront self];
  = d;
}

end;

implementation instance
it

<doc> Return a diagnostic stream.  </doc>
OutputStream
  diag
{
  = err;
}

<doc> Return a stream to which an error will be emitted.  </doc>
OutputStream
  error
{
  = [[self diag] print ("it:", [isa name], ": ")];
}

end;
