<copyright> It Line and line classes.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1998 Pieter J. Schoenmakers.

    This file is part of It.  It is distributed under the terms of the
    It License, a copy of which can be found in the It distribution; see
    the file LICENSE.

    <id>$Id: Line.t,v 1.9 1998/04/14 11:46:54 tiggr Exp $</id>
    </copyright>

/******************** line ********************/

implementation class
line: PlugIt

end;

implementation instance
line

<doc> Designated initializer.  </doc>
id
  init
{
  = [super init];
  [[ToolKit shared] newTool [LineTool self]];
}

String
  plugItName
{
  = "line";
}

int
  plugItVersion
{
  = 1000;
}

end;

/******************** Line ********************/

implementation class
Line: Shape

end;

implementation instance
Line

<doc> Designated initializer.  </doc>
id
  initWithStart (float, float) (x1, y1)
	    end (float, float) (x2, y2)
{
  points = [MutableObjectArray
	     with ([[Point alloc] init self position (x1, y1)],
		   [[Point alloc] init self position (x2, y2)])];

  (x1, y1, x2, y2) = fix_rectangle (x1, y1, x2 - x1, y2 - y1);
  (x2, y2) = (x2 + 1.0, y2 + 1.0);

  = [super initWithBBox (x1, y1, x2, y2)];
}

void
  drawSelf (float, float, float, float) (x, y, w, h)
	in Document doc
{
  Display d = [doc currentDisplay];

  [d setColor [Color black]];

  float x1, y1, x2, y2;
  (x1, y1) = [points[0] location];
  (x2, y2) = [points[1] location];

  [d drawLine (x1, y1, x2, y2)];
}

<doc> First let the Shape in the receiving line see if one of the points
    was hit.  If not, possibly the line itself was hit (in which case the
    {point} returned is {nil}).  </doc>
redefine (Object, int, Point, float, int)
	 (object, action, point, distance, priority)
  hitTest (float, float) (x, y)
  partial boolean partial_p
{
  = [super hitTest (x, y) partial partial_p];
  if (!object)
    {
      // line hit-test
      // Mon Mar  9 00:10:51 1998, tiggr@gerbil.org
    }
}

end;
