<copyright> It LineTool class.
    Written by <a href="mailto:tiggr@gerbil.org">Pieter J. Schoenmakers</a>

    Copyright &copy; 1998 Pieter J. Schoenmakers.

    This file is part of It.  It is distributed under the terms of the
    It License, a copy of which can be found in the It distribution; see
    the file LICENSE.

    <id>$Id: LineTool.t,v 1.4 1998/03/09 21:25:56 tiggr Exp $</id>
    </copyright>

implementation class
LineTool: Tool

<doc> Return {"tool-line"} and {"tool-line-h"}.  </doc>
(String, String) (normal, alternate)
  cell_images
{
  = ("tool-line", "tool-line-h");
}

end;

implementation instance
LineTool
{
  <doc> Start of the line being created.  </doc>
  float s_x, s_y;

  <doc> End of the line being created, relative to {(s_x, s_y)}.  </doc>
  float e_w, e_h;
}

void
  drawActivity (float, float, float, float) (x, y, w, h)
	    in Document doc
{
  float pr_x, pr_y, pr_w, pr_h;
  (pr_x, pr_y, pr_w, pr_h) = fix_rectangle (s_x, s_y, e_w, e_h);
  (pr_w, pr_h) = (pr_w + 1.0, pr_h + 1.0);

  if ([tag rect (pr_x, pr_y, pr_w, pr_h) intersects (x, y, w, h)])
    {
      Display d = [doc currentDisplay];

      [d setColor [Color black]];
      [d drawLine (s_x, s_y, s_x + e_w, s_y + e_h)];
    }
}

boolean
  mouseDown MouseEvent e
	 in Document doc
{
  [doc clearSelection];
  (s_x, s_y) = [e location];
  (e_w, e_h) = (0.0, 0.0);
  = TRUE;
}

void
  mouseDragged MouseEvent e
	    in Document d
{
  float pr_x = s_x, pr_y = s_y, pr_w, pr_h;
  if (e_w != 0.0 || e_h != 0.0)
    {
      (pr_x, pr_y, pr_w, pr_h) = fix_rectangle (pr_x, pr_y, e_w, e_h);
      (pr_w, pr_h) = (pr_w + 1.0, pr_h + 1.0);
    }

  float ne_x, ne_y;
  (ne_x, ne_y) = [e location];
  (e_w, e_h) = (ne_x - s_x, ne_y - s_y);

  float nr_x, nr_y, nr_w, nr_h;
  (nr_x, nr_y, nr_w, nr_h) = fix_rectangle (s_x, s_y, ne_x - s_x, ne_y - s_y);
  (nr_w, nr_h) = (nr_w + 1.0, nr_h + 1.0);

  [d display [tag unionRect (pr_x, pr_y, pr_w, pr_h)
		  with (nr_x, nr_y, nr_w, nr_h)]];
}

void
  mouseUp MouseEvent e
       in Document doc
{
  if (e_w != 0.0 || e_h != 0.0)
    [doc addObject [[Line alloc] initWithStart (s_x, s_y)
				 end (s_x + e_w, s_y + e_h)]];
}

end;
